import enticeplugin;

import std.string;


export extern(Windows) void enticePluginLoaded(EnticeFunctions* efuncs)
{
	beginEnticePlugin(efuncs); // This call is required for D and must be first.
	
	char[] s;
	
	s = "Make Selection Uppercase";
	efuncs.registerMenuItem(efuncs.id, s.ptr, s.length, eidOptions(1, ETAB_EDITOR | ESTATE_SELECTION),
		EMENU_EDIT, &_makeUpper_menuItem_click);
	
	s = "Make Selection Lowercase";
	efuncs.registerMenuItem(efuncs.id, s.ptr, s.length, eidOptions(2, ETAB_EDITOR | ESTATE_SELECTION),
		EMENU_EDIT, &_makeLower_menuItem_click);
}


private extern(Windows) void _makeUpper_menuItem_click(EnticeFunctions* efuncs, int id)
{
	int len;
	len = efuncs.getFeature(efuncs.id, EFID_EDITORGETSELTEXT, null, 0);
	if(len > 0)
	{
		char[1000] _buf;
		char[] buf = _buf;
		if(len > buf.length)
			buf = new char[len];
		len = efuncs.getFeature(efuncs.id, EFID_EDITORGETSELTEXT, buf.ptr, buf.length);
		buf = buf[0 .. len];
		buf = std.string.toupper(buf);
		efuncs.getFeature(efuncs.id, EFID_EDITORSETSELTEXT, buf.ptr, buf.length);
	}
}


private extern(Windows) void _makeLower_menuItem_click(EnticeFunctions* efuncs, int id)
{
	int len;
	len = efuncs.getFeature(efuncs.id, EFID_EDITORGETSELTEXT, null, 0);
	if(len > 0)
	{
		char[1000] _buf;
		char[] buf = _buf;
		if(len > buf.length)
			buf = new char[len];
		len = efuncs.getFeature(efuncs.id, EFID_EDITORGETSELTEXT, buf.ptr, buf.length);
		buf = buf[0 .. len];
		buf = std.string.tolower(buf);
		efuncs.getFeature(efuncs.id, EFID_EDITORSETSELTEXT, buf.ptr, buf.length);
	}
}


// This function cannot use D's garbage collector.
// Only for load parameters.
// Return one of the following:
// 	0 = Successfully load.
// 	1 = Abort load due to problem.
// 	2 = Successfully unload / prevent load.
export extern(Windows) int enticePluginLoad(EnticePluginInfo* epinfo)
{
	epinfo.name ="Edit More" ;
	
	if(epinfo.flags & 2)
		epinfo.desc = "More choices added to the Edit menu.";
	
	epinfo.thisMajorVersion = MAJOR_VERSION;
	epinfo.thisMinorVersion = MINOR_VERSION;
	
	return 0; // OK.
}


export extern(Windows) void enticePluginUnloaded(EnticeFunctions* efuncs, int n)
{
	// Plugin unloaded code goes here.
	
	endEnticePlugin(efuncs);
}

